Index: XIOS/trunk/src/type/enum.hpp
===================================================================
--- XIOS/trunk/src/type/enum.hpp	(revision 369)
+++ XIOS/trunk/src/type/enum.hpp	(revision 369)
@@ -0,0 +1,154 @@
+#ifndef __XIOS_ENUM__
+#define __XIOS_ENUM__
+
+#include "xmlioserver_spl.hpp"
+#include "exception.hpp"
+#include "buffer_in.hpp"
+#include "buffer_out.hpp"
+#include "base_type.hpp"
+#include "message.hpp"
+
+#define __INLINE__ inline
+
+
+namespace xios
+{
+  class CEnumBase
+  {
+  } ;
+  
+  template <typename T> class CEnum_ref ;
+ 
+  template <typename T> 
+  class CEnum : public  virtual CBaseType, public T
+  {
+    public:
+    typedef typename T::t_enum T_enum ;
+    CEnum(void) ;
+    __INLINE__ CEnum(const T_enum& val) ;
+    __INLINE__ CEnum(const CEnum& type) ;
+    __INLINE__ CEnum(const CEnum_ref<T>& type) ;
+    virtual ~CEnum() { _reset() ; }
+
+    __INLINE__ T_enum& get(void) ;
+    __INLINE__ const T_enum& get(void) const;
+
+    __INLINE__ void set(const T_enum& val) ;
+    __INLINE__ void set(const CEnum& val) ;
+    __INLINE__ void set(const CEnum_ref<T>& val) ;
+    __INLINE__ CEnum& operator = (const T_enum& val) ;
+    __INLINE__ CEnum& operator = (const CEnum& val) ;
+    __INLINE__ CEnum& operator = (const CEnum_ref<T>& val) ;
+    __INLINE__ operator T_enum&() ;
+        
+    virtual CEnum* clone(void) const   { return _clone(); }
+    virtual void fromString(const string& str)   { _fromString(str); }
+    virtual string toString(void) const { return _toString(); }
+    virtual bool fromBuffer(CBufferIn& buffer) { return _fromBuffer(buffer) ; }
+    virtual bool toBuffer(CBufferOut& buffer) const { return _toBuffer(buffer); }
+    virtual void reset(void) { _reset(); }
+    virtual bool isEmpty() const { return _isEmpty(); } 
+    virtual size_t size(void) const { return _size(); }
+    
+    __INLINE__ void allocate(void) ;
+    __INLINE__ void checkEmpty(void) const;
+       
+    T_enum* ptrValue ;
+    bool empty ;
+      
+    friend class CEnum_ref<T> ; 
+ 
+    private :
+ 
+    __INLINE__ CEnum* _clone(void) const;
+    __INLINE__ void _fromString(const string& str) ;
+    __INLINE__ string _toString(void) const;
+    __INLINE__ bool _fromBuffer(CBufferIn& buffer) ;
+    __INLINE__ bool _toBuffer(CBufferOut& buffer) const;
+    __INLINE__ void _reset(void) ;
+    __INLINE__ bool _isEmpty() const ;  
+    __INLINE__ size_t _size(void) const ;
+ 
+  } ;
+  
+  
+  
+  template <typename T> 
+  class CEnum_ref : public  virtual CBaseType, public T
+  {
+    public:
+    
+    typedef typename T::t_enum T_enum ;
+    __INLINE__ CEnum_ref(void) ;
+    __INLINE__ CEnum_ref(T_enum& val) ;
+    __INLINE__ CEnum_ref(CEnum<T>& type) ;
+    __INLINE__ CEnum_ref(const CEnum_ref& type) ;
+    virtual ~CEnum_ref() {};
+
+    __INLINE__ T_enum& get(void) const;
+
+    __INLINE__ void set(const T_enum& val) const ;
+    __INLINE__ void set(const CEnum<T>& val) const ;
+    __INLINE__ void set(const CEnum_ref& val) const ;
+
+    __INLINE__ void set_ref(T_enum& val) ;
+    __INLINE__ void set_ref(CEnum<T>& val) ;
+    __INLINE__ void set_ref(const CEnum_ref& val) ;
+    
+    __INLINE__ const CEnum_ref& operator = (T_enum& val) const ;
+    __INLINE__ const CEnum_ref& operator = (CEnum<T>& val) const ;
+    __INLINE__ const CEnum_ref& operator = (const CEnum_ref& val) const;
+    __INLINE__ operator T_enum&() const;
+    bool operator == (const CEnum_ref &other) {return this->get()==other.get() ;}
+
+    virtual CEnum_ref* clone(void) const   { return _clone(); }
+    virtual void fromString(const string& str)   { _fromString(str); }
+    virtual void fromString(const string& str) const  { _fromString(str); }
+    virtual string toString(void) const { return _toString(); }
+    virtual bool fromBuffer(CBufferIn& buffer) { return _fromBuffer(buffer) ; }
+    virtual bool fromBuffer(CBufferIn& buffer) const { return _fromBuffer(buffer); }
+    virtual bool toBuffer(CBufferOut& buffer) const { return _toBuffer(buffer); }
+    virtual void reset(void) { _reset(); }
+    virtual bool isEmpty() const { return _isEmpty(); } 
+    virtual size_t size(void) const { return _size(); }
+
+    __INLINE__ void checkEmpty(void) const;
+    
+
+    T_enum mutable * ptrValue ;
+    bool empty ;
+    friend class CEnum<T> ;
+    
+    private :
+    
+    __INLINE__ CEnum_ref* _clone(void) const;
+    __INLINE__ void _fromString(const string& str) ;
+    __INLINE__ void _fromString(const string& str) const;
+    __INLINE__ string _toString(void) const;
+    __INLINE__ bool _fromBuffer(CBufferIn& buffer) ;
+    __INLINE__ bool _fromBuffer(CBufferIn& buffer) const ;
+    __INLINE__ bool _toBuffer(CBufferOut& buffer) const;
+    __INLINE__ void _reset(void) ;
+    __INLINE__ bool _isEmpty() const ;  
+    __INLINE__  size_t _size(void) const ;
+  } ;
+  
+  template <typename T> __INLINE__ CBufferOut& operator<<(CBufferOut& buffer, const CEnum<T>& type) ;
+  template <typename T> __INLINE__ CBufferOut& operator<<(CBufferOut& buffer, const typename T::t_enum & type) ;  
+  template <typename T> __INLINE__ CBufferIn& operator>>(CBufferIn& buffer, CEnum<T>& type) ;
+  template <typename T> __INLINE__ CMessage& operator<<(CMessage& msg, const CEnum<T>& type) ;
+  template <typename T> __INLINE__ CMessage& operator<<(CMessage& msg, const typename T::t_enum & type) ;
+
+  template <typename T> __INLINE__ CBufferOut& operator<<(CBufferOut& buffer, const CEnum<T>& type) ;
+  template <typename T> __INLINE__ CBufferOut& operator<<(CBufferOut& buffer, const typename T::t_enum & type);
+  template <typename T> __INLINE__ CBufferIn& operator>>(CBufferIn& buffer, CEnum<T>& type);
+  template <typename T> __INLINE__ CMessage& operator<<(CMessage& msg, const CEnum<T>& type);
+  template <typename T> __INLINE__ CMessage& operator<<(CMessage& msg, const typename T::t_enum & type);
+}
+
+#  ifdef __INLINE__
+#    include "enum_impl.hpp"
+#    include "enum_ref_impl.hpp"
+#  endif
+
+#endif
Index: XIOS/trunk/src/type/enum_impl.hpp
===================================================================
--- XIOS/trunk/src/type/enum_impl.hpp	(revision 369)
+++ XIOS/trunk/src/type/enum_impl.hpp	(revision 369)
@@ -0,0 +1,293 @@
+#ifndef __XIOS_ENUM_IMPL__
+#define __XIOS_ENUM_IMPL__
+
+#include "xmlioserver_spl.hpp"
+#include "exception.hpp"
+#include "buffer_in.hpp"
+#include "buffer_out.hpp"
+#include "message.hpp"
+#include <string>
+#include <boost/algorithm/string.hpp>
+
+namespace xios
+{
+ 
+  using namespace std;
+  
+  template <typename T>
+  CEnum<T>::CEnum(void)
+  {
+    empty=true ;
+  }
+    
+  template <typename T>
+  CEnum<T>::CEnum(const T_enum& val)
+  {
+    empty=true ;
+    set(val) ;
+  }
+  
+  template <typename T>
+  CEnum<T>::CEnum(const CEnum<T>& type)
+  {
+    empty=true ;
+    set(type) ;
+  }
+
+  template <typename T>
+  CEnum<T>::CEnum(const CEnum_ref<T>& type)
+  {
+    empty=true ;
+    set(type) ;
+  }  
+
+  template <typename T>
+  void CEnum<T>::set(const T_enum& val)
+  {
+    if (empty) 
+    { 
+      ptrValue = new T_enum(val) ;
+      empty=false ;
+    }
+    else *ptrValue = val ;
+  }
+
+  template <typename T>
+  void CEnum<T>::set(const CEnum<T>& type)
+  {
+    if (type.isEmpty()) reset() ;
+    else
+    {
+      if (empty)
+      { 
+        ptrValue = new T_enum(*type.ptrValue) ;
+        empty=false ;
+      }
+      else *ptrValue = *type.ptrValue ;
+    }
+  }
+
+  template <typename T>
+  void CEnum<T>::set(const CEnum_ref<T>& type)
+  {
+    if (type.isEmpty()) reset() ;
+    else
+    {
+      if (empty)
+      { 
+        ptrValue = new T_enum(*type.ptrValue) ;
+        empty=false ;
+      }
+      else *ptrValue = *type.ptrValue ;
+    }
+  }
+
+
+  template <typename T>
+  typename T::t_enum & CEnum<T>::get(void)
+  {
+    checkEmpty();
+    return *ptrValue ;
+  }
+
+  template <typename T>
+  const typename T::t_enum& CEnum<T>::get(void) const
+  {
+    checkEmpty();
+    return *ptrValue ;
+  }
+  
+  template <typename T>
+  CEnum<T>& CEnum<T>::operator = (const T_enum& val)
+  {
+    set(val) ;
+    return *this ;
+  }
+  
+  template <typename T>
+  CEnum<T>& CEnum<T>::operator = (const CEnum<T>& type)
+  {
+    set(type) ;
+    return *this ;
+  }
+
+  template <typename T>
+  CEnum<T>& CEnum<T>::operator = (const CEnum_ref<T>& type)
+  {
+    set(type) ;
+    return *this ;
+  }
+
+
+  template <typename T>
+  CEnum<T>::operator T_enum&()
+  {
+    cout<<"CEnum<T>::operator T_enum&()"<<endl ;
+    checkEmpty();
+    return *ptrValue ;
+   }
+
+   template <typename T>
+   CEnum<T>* CEnum<T>::_clone(void) const
+   {
+     checkEmpty();
+     return new CEnum(*this) ;
+   }
+
+  
+  template <class T>
+  void CEnum<T>::_fromString(const string& str)
+  {
+    string tmpStr=boost::to_lower_copy(boost::trim_copy(str)) ;
+    
+    bool found=false ;
+    for(int i=0;i<T::getSize();i++)
+    {
+      if (boost::to_lower_copy(string(T::getStr()[i]))==tmpStr)
+      {
+        allocate() ;
+        *ptrValue=(T_enum) i ;
+        return ;
+      }
+    }
+    
+    ostringstream strList ;
+    for(int i=0;i<T::getSize();i++) 
+    {
+      if (i>0) strList<<", " ;
+      strList<<boost::to_lower_copy(string(T::getStr()[i])) ;
+    }
+    
+    ERROR("template <typename T> void CEnum<T>::_fromString(const string& str)",
+    << tmpStr << " cannot be converted in a valid enumeration, possibilities are : "<<strList.str() ) ;
+
+  }
+
+  template <typename T>
+  size_t CEnum<T>::_size(void) const
+  {
+    return sizeof(T_enum) ;
+  }
+  
+  template <typename T>
+  bool CEnum<T>::_isEmpty(void) const
+  {
+    return empty ;
+  }
+  
+  template <typename T>
+  string CEnum<T>::_toString(void) const
+  {
+    if (!empty) return string((T::getStr())[(int)(*ptrValue)]) ;
+  }
+  
+  template <typename T>
+  bool CEnum<T>::_toBuffer(CBufferOut& buffer) const
+  {
+    checkEmpty();
+    if (sizeof(*ptrValue)==sizeof(short int)) return buffer.put((short int) *ptrValue) ;
+    else if (sizeof(*ptrValue)==sizeof(int)) return buffer.put((int) *ptrValue) ;
+    else if (sizeof(*ptrValue)==sizeof(long int)) return buffer.put((long int) *ptrValue) ;
+    else ERROR("template <typename T>  bool CEnum<T>::_toBuffer(CBufferOut& buffer) const",
+               <<"incompatibility between enumeration and standard integer type") ;
+  }
+  
+  template <typename T>
+  bool CEnum<T>::_fromBuffer(CBufferIn& buffer)
+  {
+    bool ret ;
+    allocate() ;
+    if (sizeof(*ptrValue)==sizeof(short int)) 
+    {
+      short int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else if (sizeof(*ptrValue)==sizeof(int)) 
+    {
+      int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else if (sizeof(*ptrValue)==sizeof(long int)) 
+    {
+      long int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else ERROR("template <typename T>  bool CEnum<T>::_fromBuffer(CBufferIn& buffer)",
+               <<"incompatibility between enumeration and standard integer type") ;
+    return ret ;
+  }
+ 
+
+  template <typename T>
+  void CEnum<T>::allocate(void)
+  {
+    if (empty) 
+    {
+      ptrValue = new T_enum ;
+      empty=false ;
+    }
+  }
+  
+  template <typename T>
+  void CEnum<T>::_reset(void)
+  {
+    if (!empty) 
+    {
+      delete ptrValue ;
+      empty=true ;
+    }
+  }
+  
+  template <typename T>
+  void CEnum<T>::checkEmpty(void) const
+  {
+    if (empty) ERROR("template <typename T> void CEnum<T>::checkEmpty(void) const", <<"Type is not initialized") ;
+  }  
+
+  
+  template <typename T>
+  CBufferOut& operator<<(CBufferOut& buffer, const CEnum<T>& type)
+  {
+    if (!type.toBuffer(buffer)) ERROR("template <typename T> CBufferOut& operator<<(CBufferOut& buffer, const CEnum<T>& type)",
+                                           <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+
+  template <typename T>
+  CBufferOut& operator<<(CBufferOut& buffer, const typename T::t_enum & type)
+  {
+    if (!CEnum<T>(type).toBuffer(buffer)) ERROR("template <typename T> CBufferOut& operator<<(CBufferOut& buffer, const typename T::t_enum & type)",
+                                           <<"Buffer remain size is to low for size type") ;      
+    return buffer ;
+  }
+  
+  template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, CEnum<T>& type)
+  {
+    if (! type.fromBuffer(buffer)) ERROR("template <typename T> CBufferIn& operator>>(CBufferIn& buffer, CEnum<T>& type)",
+                                           <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+  
+ 
+  template <typename T>
+  CMessage& operator<<(CMessage& msg, const CEnum<T>& type)
+  {
+    msg.push(*type.clone()) ;
+    return msg ;
+  }
+
+  template <typename T>
+  CMessage& operator<<(CMessage& msg, const typename T::t_enum & type)
+  {
+    msg.push(*CEnum<T>(type).clone()) ;
+    return msg ;
+  }
+  
+}
+
+#endif
+
Index: XIOS/trunk/src/type/enum_ref_impl.hpp
===================================================================
--- XIOS/trunk/src/type/enum_ref_impl.hpp	(revision 369)
+++ XIOS/trunk/src/type/enum_ref_impl.hpp	(revision 369)
@@ -0,0 +1,317 @@
+#ifndef __XIOS_ENUM_REF_IMPL__
+#define __XIOS_ENUM_REF_IMPL__
+
+#include "xmlioserver_spl.hpp"
+#include "exception.hpp"
+#include "buffer_in.hpp"
+#include "buffer_out.hpp"
+#include "message.hpp"
+#include <string>
+#include <boost/algorithm/string.hpp>
+
+namespace xios
+{
+ 
+    
+  using namespace std;
+  
+  template <typename T>
+  CEnum_ref<T>::CEnum_ref(void)
+  {
+    empty=true ;
+  }
+    
+  template <typename T>
+  CEnum_ref<T>::CEnum_ref(T_enum& val)
+  {
+    empty=true ;
+    set_ref(val) ;
+  }
+  
+  template <typename T>
+  CEnum_ref<T>::CEnum_ref(CEnum<T>& type)
+  {
+    empty=true ;
+    set_ref(type) ;
+  }
+
+  template <typename T>
+  CEnum_ref<T>::CEnum_ref(const CEnum_ref<T>& type)
+  {
+    empty=true ;
+    set_ref(type) ;
+  }  
+
+  
+  template <typename T>
+  void CEnum_ref<T>::set_ref(T_enum& val)
+  {
+    ptrValue=&val ;
+    empty=false ;
+  }
+
+  template <typename T>
+  void CEnum_ref<T>::set_ref(CEnum<T>& type)
+  {
+    ptrValue=&type.get() ;
+    empty=false ;
+  }
+
+  template <typename T>
+  void CEnum_ref<T>::set_ref(const CEnum_ref<T>& type)
+  {
+    ptrValue=type.ptrValue ;
+    empty=type.empty ;
+  }
+
+  template <typename T>
+  void CEnum_ref<T>::set(const T_enum& val) const
+  {
+    checkEmpty() ;
+    *ptrValue=val ;
+  }
+
+  template <typename T>
+  void CEnum_ref<T>::set(const CEnum<T>& type) const
+  {
+    checkEmpty() ;
+    *ptrValue=type.get() ;
+  }
+
+  template <typename T>
+  void CEnum_ref<T>::set(const CEnum_ref<T>& type) const
+  {
+    checkEmpty() ;
+    *ptrValue=type.get() ;
+  }
+  
+  template <typename T>
+  typename T::t_enum & CEnum_ref<T>::get(void) const
+  {
+    checkEmpty() ;
+    return *ptrValue ;
+  }
+  
+  template <typename T>
+  const CEnum_ref<T>& CEnum_ref<T>::operator = (T_enum& val) const
+  {
+    set(val) ;
+    return *this ;
+  }
+
+  template <typename T>
+  const CEnum_ref<T>& CEnum_ref<T>::operator = (CEnum<T>& type) const
+  {
+    set(type) ;
+    return *this ;
+  }
+   
+  template <typename T>
+  const CEnum_ref<T>& CEnum_ref<T>::operator = (const CEnum_ref<T>& type) const
+  {
+    set(type) ;
+    return *this ;
+  }
+  
+  template <typename T>
+  CEnum_ref<T>::operator T_enum&() const
+  {
+    checkEmpty() ;
+    return *ptrValue ;
+  }
+
+  template <typename T>
+  CEnum_ref<T>* CEnum_ref<T>::_clone(void) const
+  {
+    checkEmpty() ;
+    return new CEnum_ref<T>(*this) ;
+  }
+   
+  template <typename T>
+  void CEnum_ref<T>::_fromString(const string& str) const
+  {
+    istringstream iss(str);
+    checkEmpty() ;
+    iss>>*ptrValue ;
+  }
+ 
+  template <typename T>
+  void CEnum_ref<T>::_fromString(const string& str)
+  {
+    checkEmpty() ;
+    string tmpStr=boost::to_lower_copy(boost::trim_copy(str)) ;
+    
+    bool found=false ;
+    for(int i=0;i<T::getSize();i++)
+    {
+      if (boost::to_lower_copy(string(T::getStr()[i]))==tmpStr)
+      {
+        *ptrValue=(T_enum) i ;
+        return ;
+      }
+    }
+    
+    ostringstream strList ;
+    for(int i=0;i<T::getSize();i++) 
+    {
+      if (i>0) strList<<", " ;
+      strList<<boost::to_lower_copy(string(T::getStr()[i])) ;
+    }
+    
+    ERROR("template <typename T> void CEnum_ref<T>::_fromString(const string& str)",
+    << tmpStr << " cannot be converted in a valid enumeration, possibilities are : "<<strList.str() ) ;
+  }
+  
+  template <typename T>
+  string CEnum_ref<T>::_toString(void) const
+  {
+    if (!empty) return string((T::getStr())[(int)(*ptrValue)]) ;
+  }
+
+    
+  template <typename T>
+  bool CEnum_ref<T>::_toBuffer(CBufferOut& buffer) const
+  {
+    checkEmpty() ;
+    if (sizeof(*ptrValue)==sizeof(short int)) return buffer.put((short int) *ptrValue) ;
+    else if (sizeof(*ptrValue)==sizeof(int)) return buffer.put((int) *ptrValue) ;
+    else if (sizeof(*ptrValue)==sizeof(long int)) return buffer.put((long int) *ptrValue) ;
+    else ERROR("template <typename T>  bool CEnum_ref<T>::_toBuffer(CBufferOut& buffer) const",
+               <<"incompatibility between enumeration and standard integer type") ;
+  }
+  
+  template <typename T>
+  bool CEnum_ref<T>::_fromBuffer(CBufferIn& buffer)
+  {
+    checkEmpty() ;
+    bool ret ;
+    if (sizeof(*ptrValue)==sizeof(short int)) 
+    {
+      short int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else if (sizeof(*ptrValue)==sizeof(int)) 
+    {
+      int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else if (sizeof(*ptrValue)==sizeof(long int)) 
+    {
+      long int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else ERROR("template <typename T>  bool CEnum_ref<T>::_fromBuffer(CBufferIn& buffer)",
+               <<"incompatibility between enumeration and standard integer type") ;
+    return ret ;
+  }
+ 
+  template <typename T>
+  bool CEnum_ref<T>::_fromBuffer(CBufferIn& buffer) const
+  {
+    checkEmpty() ;
+    bool ret ;
+    if (sizeof(*ptrValue)==sizeof(short int)) 
+    {
+      short int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else if (sizeof(*ptrValue)==sizeof(int)) 
+    {
+      int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else if (sizeof(*ptrValue)==sizeof(long int)) 
+    {
+      long int val ;
+      ret=buffer.get(val) ;
+      if (ret) *ptrValue = (T_enum) val ;
+    }
+    else ERROR("template <typename T>  bool CEnum_ref<T>::_fromBuffer(CBufferIn& buffer)",
+               <<"incompatibility between enumeration and standard integer type") ;
+  }
+ 
+  template <typename T>
+  size_t CEnum_ref<T>::_size(void) const
+  {
+    return sizeof(T_enum) ;
+  }
+  
+  template <typename T>
+  bool CEnum_ref<T>::_isEmpty(void) const
+  {
+    return empty ;
+  }
+   
+  template <typename T>
+  void CEnum_ref<T>::_reset(void)
+  {
+      empty=true ;
+  }
+  
+  template <typename T>
+  void CEnum_ref<T>::checkEmpty(void) const
+  {
+    if (empty) ERROR("template <typename T> void CEnum_ref<T>::checkEmpty(void)",
+                     <<"Type_ref reference is not assigned") ;
+  }
+                     
+
+  
+  template <typename T>
+  CBufferOut& operator<<(CBufferOut& buffer, const CEnum_ref<T>& type)
+  {
+    if (!type.toBuffer(buffer)) ERROR("template <typename T> CBufferOut& operator<<(CBufferOut& buffer, const CEnum_ref<T>& type)",
+                                           <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+
+  template <typename T>
+  CBufferOut& operator<<(CBufferOut& buffer, typename T::t_enum& type)
+  {
+    if (!CEnum_ref<T>(type).toBuffer(buffer)) ERROR("template <typename T> CBufferOut& operator<<(CBufferOut& buffer, const typename T::t_enum& type)",
+                                             <<"Buffer remain size is to low for size type") ;      
+    return buffer ;
+  }
+
+  template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, typename T::t_enum& type)
+  {
+    if (! CEnum_ref<T>(type).fromBuffer(buffer)) ERROR("template <typename T>  CBufferIn& operator>>(CBufferIn& buffer, typename T::t_enum& type)",
+                                                       <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+
+  template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, const CEnum_ref<T>& type)
+  {
+    if (! type.fromBuffer(buffer) ) ERROR("  template <typename T> CBufferIn& operator>>(CBufferIn& buffer, const CEnum_ref<T>& type) ",
+                                           <<"Buffer remain size is to low for size type") ;
+    return buffer ;
+  }
+
+
+
+  template <typename T>
+  CMessage& operator<<(CMessage& msg, const CEnum_ref<T>& type)
+  {
+    msg.push(*type.clone()) ;
+    return msg ;
+  }
+
+
+  template <typename T>
+  CMessage& operator<<(CMessage& msg, typename T::t_enum & type)
+  {
+    msg.push(*CEnum_ref<T>(type).clone()) ;
+    return msg ;
+  }
+  
+}
+
+#endif
+
Index: XIOS/trunk/src/type/message.cpp
===================================================================
--- XIOS/trunk/src/type/message.cpp	(revision 368)
+++ XIOS/trunk/src/type/message.cpp	(revision 369)
@@ -12,13 +12,13 @@
    CMessage& CMessage::push(const CBaseType& type)
    {
-     typeList.push_back(type.duplicate());
+     typeList.push_back(type.clone());
      return *this ;
    }
    
-    CMessage& CMessage::push(CBaseType& type)
-   {
-     typeList.push_back(&type);
-     return *this ;
-   }
+//    CMessage& CMessage::push(CBaseType& type)
+//   {
+//     typeList.push_back(&type);
+//     return *this ;
+//   }
    
    size_t CMessage::size(void) const
@@ -66,5 +66,5 @@
     {
       list<CBaseType*>::iterator it; 
-      for(it=typeList.begin();it!=typeList.end();it++) (*it)->destroy() ;
+      for(it=typeList.begin();it!=typeList.end();it++) delete *it ;
       typeList.clear() ;
     }
@@ -97,9 +97,9 @@
   }
 
-  CMessage& operator<<(CMessage& msg, const CBaseType&  type)
-  {
-    msg.push(*type.duplicate()) ;
-    return msg ;
-  } 
+//  CMessage& operator<<(CMessage& msg, const CBaseType&  type)
+//  {
+//    msg.push(*type.clone()) ;
+//    return msg ;
+//  } 
   
 }
Index: XIOS/trunk/src/type/message.hpp
===================================================================
--- XIOS/trunk/src/type/message.hpp	(revision 368)
+++ XIOS/trunk/src/type/message.hpp	(revision 369)
@@ -12,5 +12,5 @@
 {
 
-  class CMessage : public CBaseType 
+  class CMessage
   {
     public:
@@ -23,5 +23,5 @@
   
     CMessage& push(const CBaseType& type) ; 
-    CMessage& push(CBaseType& type) ;
+//    CMessage& push(CBaseType& type) ;
     void clear(void) ;  
     ~CMessage() ;    
@@ -31,5 +31,5 @@
   CBufferIn& operator>>(CBufferIn& buffer, CMessage& msg) ;
 
-  CMessage& operator<<(CMessage& msg,CBaseType& type) ;
+//  CMessage& operator<<(CMessage& msg,CBaseType& type) ;
   CMessage& operator<<(CMessage& msg,const CBaseType& type) ;
  
Index: XIOS/trunk/src/type/type.hpp
===================================================================
--- XIOS/trunk/src/type/type.hpp	(revision 368)
+++ XIOS/trunk/src/type/type.hpp	(revision 369)
@@ -12,6 +12,8 @@
 {
 
+  template <typename T> class CType_ref ;
+    
   template <typename T> 
-  class CType : public CBaseType
+  class CType : public  virtual CBaseType
   {
     public:
@@ -19,34 +21,118 @@
     CType(void) ;
     CType(const T& val) ;
-    CType(T& val) ;
     CType(const CType& type) ;
+    CType(const CType_ref<T>& type) ;
+    virtual ~CType() { _reset() ; }
 
-    ~CType() {} ;
+    T& get(void) ;
+    const T& get(void) const;
 
-    void fromString(const string& str) ;
-    string toString(void) const;
+    void set(const T& val) ;
+    void set(const CType& val) ;
+    void set(const CType_ref<T>& val) ;
+    CType& operator = (const T& val) ;
+    CType& operator = (const CType& val) ;
+    CType& operator = (const CType_ref<T>& val) ;
+    operator T&() ;
     
-    bool fromBuffer(CBufferIn& buffer) ;
-    bool toBuffer(CBufferOut& buffer) const;
-    void destroy(void) ;
+    virtual CType* clone(void) const   { return _clone(); }
+    virtual void fromString(const string& str)   { _fromString(str); }
+    virtual string toString(void) const { return _toString(); }
+    virtual bool fromBuffer(CBufferIn& buffer) { return _fromBuffer(buffer) ; }
+    virtual bool toBuffer(CBufferOut& buffer) const { return _toBuffer(buffer); }
+    virtual void reset(void) { _reset(); }
+    virtual bool isEmpty() const { return _isEmpty(); } 
+    virtual size_t size(void) const { return _size(); }
     
-    size_t size(void) const;
-    CBaseType* duplicate(void) const;  
-
-    void checkAccess(void) const;
+    void allocate(void) ;
+    void checkEmpty(void) const;
+       
     T* ptrValue ;
-    
-    bool clone ;
-    T value ; 
+    bool empty ;
+      
+    friend class CType_ref<T> ; 
+ 
+    private :
+ 
+    CType* _clone(void) const;
+    void _fromString(const string& str) ;
+    string _toString(void) const;
+    bool _fromBuffer(CBufferIn& buffer) ;
+    bool _toBuffer(CBufferOut& buffer) const;
+    void _reset(void) ;
+    bool _isEmpty() const ;  
+    size_t _size(void) const ;
+ 
   } ;
 
+
+  template<typename T> class CType ;
+    
+  template <typename T> 
+  class CType_ref : public virtual CBaseType
+  {
+    public:
+  
+    CType_ref(void) ;
+    CType_ref(T& val) ;
+    CType_ref(CType<T>& type) ;
+    CType_ref(const CType_ref& type) ;
+    virtual ~CType_ref() {};
+
+    T& get(void) const;
+
+    void set(const T& val) const ;
+    void set(const CType<T>& val) const ;
+    void set(const CType_ref& val) const ;
+
+    void set_ref(T& val) ;
+    void set_ref(CType<T>& val) ;
+    void set_ref(const CType_ref& val) ;
+    
+    const CType_ref& operator = (T& val) const ;
+    const CType_ref& operator = (CType<T>& val) const ;
+    const CType_ref& operator = (const CType_ref& val) const;
+    operator T&() const;
+
+    virtual CType_ref* clone(void) const   { return _clone(); }
+    virtual void fromString(const string& str)   { _fromString(str); }
+    virtual void fromString(const string& str) const  { _fromString(str); }
+    virtual string toString(void) const { return _toString(); }
+    virtual bool fromBuffer(CBufferIn& buffer) { return _fromBuffer(buffer) ; }
+    virtual bool fromBuffer(CBufferIn& buffer) const { return _fromBuffer(buffer); }
+    virtual bool toBuffer(CBufferOut& buffer) const { return _toBuffer(buffer); }
+    virtual void reset(void) { _reset(); }
+    virtual bool isEmpty() const { return _isEmpty(); } 
+    virtual size_t size(void) const { return _size(); }
+
+    void checkEmpty(void) const;
+    
+
+    T mutable * ptrValue ;
+    bool empty ;
+    friend class CType<T> ;
+    
+    private :
+    
+    CType_ref* _clone(void) const;
+    void _fromString(const string& str) ;
+    void _fromString(const string& str) const;
+    string _toString(void) const;
+    bool _fromBuffer(CBufferIn& buffer) ;
+    bool _fromBuffer(CBufferIn& buffer) const ;
+    bool _toBuffer(CBufferOut& buffer) const;
+    void _reset(void) ;
+    bool _isEmpty() const ;  
+    size_t _size(void) const ;
+  } ;
+  
+  
   class CMessage ;
   
   template <typename T>
   CBufferOut& operator<<(CBufferOut& buffer, const CType<T>& type) ;
-  
 
   template <typename T>
-  CBufferOut& operator<<(CBufferOut& buffer, T& type) ;
+  CBufferOut& operator<<(CBufferOut& buffer, const CType_ref<T>& type) ;
   
   template <typename T>
@@ -54,28 +140,35 @@
   
   template <typename T>
-  CBufferIn& operator>>(CBufferIn& buffer, const CType<T>& type) ;
-  
-  template <typename T>
-  CBufferIn& operator>>(CBufferIn& buffer, T& type) ;
-  
+  CBufferOut& operator<<(CBufferOut& buffer, T& type) ;
 
 
   template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, CType<T>& type) ;
+
+  template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, const CType_ref<T>& type) ;
+
+  template <typename T>
+  CBufferIn& operator>>(CBufferIn& buffer, T& type) ;
+
+  template <typename T>
   CMessage& operator<<(CMessage& msg, const CType<T>& type) ;
+
+  template <typename T>
+  CMessage& operator<<(CMessage& msg, const CType_ref<T>& type) ;
   
-  template <typename T>
-  CMessage& operator<<(CMessage& msg,CType<T>& type) ;
   
   template <typename T>
   CMessage& operator<<(CMessage& msg, const T& type) ;
-  
+
   template <typename T>
   CMessage& operator<<(CMessage& msg, T& type) ;
-  
+
 }
 
 
-//#include "type_impl.hpp"
-//#include "type_specialisation.hpp"
+//#include "test_type_impl.hpp"
+//#include "test_type_specialisation.hpp"
 
 #endif
+
Index: XIOS/trunk/src/type/type_decl.cpp
===================================================================
--- XIOS/trunk/src/type/type_decl.cpp	(revision 368)
+++ XIOS/trunk/src/type/type_decl.cpp	(revision 369)
@@ -1,3 +1,5 @@
+#include "type.hpp"
 #include "type_impl.hpp"
+#include "type_ref_impl.hpp"
 #include "type_specialisation.hpp"
 #include <string> ;
@@ -8,11 +10,14 @@
 #define macro(decl_type)         \
   template class CType<decl_type> ; \
+  template class CType_ref<decl_type> ; \
   template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const CType<decl_type>& type) ; \
+  template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const CType_ref<decl_type>& type) ; \
   template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, decl_type& type) ; \
   template CBufferOut& operator<< <decl_type> (CBufferOut& buffer, const decl_type& type) ; \
-  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, const CType<decl_type>& type) ; \
+  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, CType<decl_type>& type) ; \
+  template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, const CType_ref<decl_type>& type) ; \
   template CBufferIn& operator>> <decl_type> (CBufferIn& buffer, decl_type& type) ; \
   template CMessage& operator<< <decl_type> (CMessage& msg, const CType<decl_type>& type) ;\
-  template CMessage& operator<< <decl_type> (CMessage& msg,CType<decl_type>& type) ; \
+  template CMessage& operator<< <decl_type> (CMessage& msg, const CType_ref<decl_type>& type) ; \
   template CMessage& operator<< <decl_type> (CMessage& msg, const decl_type& type) ; \
   template CMessage& operator<< <decl_type> (CMessage& msg, decl_type& type) ;
@@ -23,6 +28,4 @@
   macro(bool)  
   macro(StdSize) 
-  macro(ARRAY(double,1)) 
-  macro(ARRAY(int,1)) 
-  macro(ARRAY(bool,2))
+
 }
